// here comes the html css and javascript magic
String html_css_js = R"=====(
<!DOCTYPE html>
<html>
<head>    
  <title>neo lamp</title>
  <script>
    var rainbowEnable = false;
    var onOff = false;
    var connection = new WebSocket('ws://'+location.hostname+':81/', ['arduino']);
    connection.onopen = function () {
        connection.send('Connect ' + new Date());
    };
    connection.onerror = function (error) {
        console.log('WebSocket Error ', error);
    };
    connection.onmessage = function (e) {  
        console.log('Server: ', e.data);
    };
    connection.onclose = function(){
        console.log('WebSocket connection closed');
    };
    
    function sendRGBW() {
        var r = document.getElementById('r').value;
        var g = document.getElementById('g').value;
        var b = document.getElementById('b').value;
        var w = document.getElementById('w').value;
        
        var rgbw = r << 24 | g << 16 | b << 8 | w;
        var rgbw_str = '#'+ rgbw.toString(16);    
        console.log('RGBW: ' + rgbw_str); 
        connection.send(rgbw_str);
    }
    
    function rainbowEffect(){
        rainbowEnable = ! rainbowEnable;
        if(rainbowEnable){
            connection.send("R");
            document.getElementById('rainbow').style.backgroundColor = '#00878F';
            document.getElementById('r').className = 'disabled';
            document.getElementById('g').className = 'disabled';
            document.getElementById('b').className = 'disabled';
            document.getElementById('w').className = 'disabled';
            document.getElementById('r').disabled = true;
            document.getElementById('g').disabled = true;
            document.getElementById('b').disabled = true;
            document.getElementById('w').disabled = true;
        } else {
            connection.send("N");
            document.getElementById('rainbow').style.backgroundColor = '#999';
            document.getElementById('r').className = 'enabled';
            document.getElementById('g').className = 'enabled';
            document.getElementById('b').className = 'enabled';
            document.getElementById('w').className = 'enabled';
            document.getElementById('r').disabled = false;
            document.getElementById('g').disabled = false;
            document.getElementById('b').disabled = false;
            document.getElementById('w').disabled = false;
            sendRGBW();
        }  
    }

   function onoff(){
        onOff = ! onOff;
        if(onOff){
            connection.send("O");
            document.getElementById('onoff').style.backgroundColor = '#00878F';
            var r = document.getElementById('r');
            r.value = 255;
            var g = document.getElementById('g');
            g.value = 255;
            var b = document.getElementById('b');
            b.value = 255;
            var w = document.getElementById('w');
            w.value = 255;            
            sendRGBW();
        } else {
            connection.send("F");
            document.getElementById('onoff').style.backgroundColor = '#999';
            var r = document.getElementById('r');
            r.value = 0;
            var g = document.getElementById('g');
            g.value = 0;
            var b = document.getElementById('b');
            b.value = 0;
            var w = document.getElementById('w');
            w.value = 0;           
            sendRGBW();
        }  
    }

  
  </script>
</head>
<style>
  center {
    width: 800px;
    max-width: 100%;
    margin: 0px auto;
    font-family: 'Roboto', sans-serif;
    color: #444;
    font-size: 180% 
  }
  header {
    background-color: #00878F;
    color: white;
    padding: 32px;
    font-family: 'Roboto', sans-serif;
    box-shadow: 1px 1px 5px #555555;
    position: relative;
  }
  h1 {
    margin: 0px;
    font-family: 'Roboto', sans-serif;
    font-size: 36;
  }
  center>div {
    padding: 24px 10px 10px 10px;
    box-shadow: 1px 1px 5px #555555;    
  }
  table {
    margin: 20px 24px 20px 12px;    
  }
  td {
    color: #555;
    width: 100%;        
  }
  tr {
    width: 100%;      
  }
  .button {
    text-decoration: none;
    border: none;
    color: white;
    background-color: #00878F;
    padding: 6px 24px;
    font-size: 32px;
    cursor: pointer;
    box-shadow: 1px 1px 6px #555;
    outline: none;
    margin: 12px auto 0px auto;
    display: inline-block;
  }
  .button:hover {
    box-shadow: 1px 1px 3px #444;
  }
  input[type=range] {
    -webkit-appearance: none;
    outline: none;
    width: 100%;    
    margin: 32px;
  }
  input[type=range]::-webkit-slider-thumb {
    -webkit-appearance: none;
    border: 0px;
    height: 15px;
    width: 15px;
    margin-top: -6px;
    border-radius: 7.5px;
  }
  input.disabled[type=range]::-webkit-slider-thumb {
    background: #999;
  }
  input.enabled[type=range]::-webkit-slider-thumb {
    background: #00878F;
    cursor: pointer;
    box-shadow: 1px 1px 2px #777, 0px 0px 1px #777;
  }
  
  input[type=range]::-webkit-slider-runnable-track {
    width: inherit;
    height: 10px;
    background: #ccc;
    border-radius: 1px;
  }
  input.enabled[type=range]::-webkit-slider-runnable-track {
    cursor: pointer;
  }
</style>
<body>
  <center>
    <header>
      <h1>NEO LAMP</h1>
    </header>
    <div>
      <table>
        <tr>
          <td style="width:18px; text-align: right">R: </td>
          <td><input class="enabled" id="r" type="range" min="0" max="255"
               step="1" oninput="sendRGBW();" value="0"></td>
        </tr>
        <tr>
          <td style="width:18px; text-align: right">G: </td>
          <td><input class="enabled" id="g" type="range" min="0" max="255"
               step="1" oninput="sendRGBW();" value="0"></td>
        </tr>
        <tr>
           <td style="width:18px; text-align: right">B: </td>
           <td><input class="enabled" id="b" type="range" min="0" max="255"
                step="1" oninput="sendRGBW();" value="0"></td>
        </tr>
        <tr>
           <td style="width:18px; text-align: right">W: </td>
           <td><input class="enabled" id="w" type="range" min="0" max="255"
                step="1" oninput="sendRGBW();" value="0"></td>
        </tr>
      </table>
      <p style="margin:8px 0px">
        <button id="onoff" class="button" style="background-color:#999"
                onclick="onoff();">On/Off</button>
         <button id="rainbow" class="button" style="background-color:#999" 
                onclick="rainbowEffect();">Rainbow</button>
      </p>
    </div>
  </center>
</body>
</html>
)=====";
